unit pawnev;

interface
uses params,eval,bitboards,hash;
Const
WPSQ : Tsq =
     (
         0,  0,  0,  0,  0,  0,  0,  0,
        -3,  0,  3,  6,  6,  3,  0, -3,
        -3,  0,  3, 10, 10,  3,  0, -3,
        -3,  0,  8, 16, 16,  8,  0, -3,
        -3,  0,  6, 12, 12,  6,  0, -3,
        -3,  0,  3,  6,  6,  3,  0, -3,
        -3,  0,  3,  6,  6,  3,  0, -3,
         0,  0,  0,  0,  0,  0,  0,  0
      );

IsoMid:t8=(0,10,10,11,12,12,11,10,10);
IsoEnd:t8=(0,18,18,19,20,20,19,18,18);
DoubledMid:t8=(0,7,6,6,6,6,6,6,7);
DoubledEnd:t8=(0,10,10,10,10,10,10,10,10);
WeakMid:t8=(0,10,10,10,12,12,10,10,10);
WeakEnd:t8=(0,14,14,14,16,16,14,14,14);
OnOpen=10;
PasserBegin=20;
PasserMid:t8=(0,0,10,10,17,30,50,70,0);
PasserMul:t8=(0,0,0,0,10,30,45,64,0);
PasserStrong=30;
FreePasser=50;
Candidat:t8=(0,0,5,5,10,15,25,0,0);
CandidatEnd:t8=(0,0,10,10,20,30,50,0,0);
AttDist=5;
DefDist=20;
duo=2;
Unstoppable = 600;
KingSupported=60;
OpenCenter=0;
HalfOpenCenter=1;
ClosedCenter=2;

Procedure PawnEval(ply:integer;var pscore:integer;var pend:integer;dir:integer);
Procedure PassPawnEval(color:integer;ply:integer);
implementation
uses safety,attacks;

Procedure PawnEval(ply:integer;var pscore:integer;var pend:integer;dir:integer);
//label l1,l2;
const
    only32 :t8=(0,1,2,4,8,16,32,64,128);
var
   i,sq,x,y,att,def,dbl,indx,tdata: integer;
   WP,BP,Wadv,Badv,temp: bitboard;
   backward,cand,pass :boolean;
begin
  //     :
  indx:=tree[dir].PHash and PHashMask;
  if PTable[indx].key=tree[dir].PHash then
     begin
       pscore:=PTable[indx].pscore;
       tdata:=PTable[indx].data;
       pend:=PTable[indx].pend;
       wpassvector:=tdata and 255;
       bpassvector:=(tdata shr 8) and 255;
       center:=(tdata shr 16) and 255;
       exit;
     end;
//   
  wadv:=0;badv:=0;
  temp:=WhitePawns;
  while temp<>0 do
    begin
      sq:=BitScanForward(temp);
      i:=sq;
      while i+8<a8 do
        begin
          if (Only[i+8] and all)<>0 then break;
          att:=BitCount(WpAttacks[i+8] and BlackPawns);
          def:=BitCount(BpAttacks[i+8] and  WhitePawns);
          if def>=att then wadv:=wadv or Only[i+8] else break;
          inc(i,8);
        end;
      temp:=temp and NotOnly[sq];
    end;
  temp:=BlackPawns;
  while temp<>0 do
    begin
      sq:=BitScanForward(temp);
      i:=sq;
      while i-8>h1 do
        begin
          if (Only[i-8] and all)<>0 then break;
          def:=BitCount(WpAttacks[i-8] and BlackPawns);
          att:=BitCount(BpAttacks[i-8] and  WhitePawns);
          if def>=att then badv:=badv or Only[i-8] else break;
          dec(i,8);
        end;
      temp:=temp and NotOnly[sq];
    end;
  pscore:=0;pend:=0;wpassvector:=0;bpassvector:=0;
 //  
  temp:=WhitePawns;
  while temp<>0 do
    begin
      pass:=false;
      sq:=BitScanForward(temp);
      x:=Posx[sq];y:=posy[sq];
     //      .
      pscore:=pscore+WPSQ[sq];
      dbl:=BitCount(WhitePawns and (Files[x]));
      //  :
      if ((WPassMask[sq] and BlackPawns)=0) then
        begin
          wpassvector:=wpassvector or Only32[x];
          pass:=true;
        end;
      if (IsoMask[sq] and WhitePawns)=0 then
         begin
          //  
            pscore:=pscore-IsoMid[x];
            if (Wstopper[sq] and all)=0 then pscore:=pscore-OnOpen;
            pend:=pend-IsoEnd[x];
         end
            else
        begin
        //    
        if ((Wback[sq] and WhitePawns)=0)  then
           begin
           backward:=true;
           if ((Only[sq+8] and wadv)<>0) then
            begin
             if ((BPAttacks[sq+8] and WhitePawns)<>0) then backward:=false else
               if (y=2) and ((Only[sq+16] and wadv)<>0) and ((BPAttacks[sq+16] and WhitePawns)<>0) then backward:=false;
            end;
           if (backward) then
              begin
                pscore:=pscore-WeakMid[x];
                if (Wstopper[sq] and all)=0 then pscore:=pscore-OnOpen;
                pend:=pend-WeakEnd[x];
              end;
           end;
       end;
      //   :
      if (dbl>1) then
        begin
          pscore:=pscore-DoubledMid[x];
          pend:=pend-DoubledEnd[x];
        end;
      if ((x>1) and ((Only[sq-1] and WhitePawns)<>0)) or ((x<8) and ((Only[sq+1] and WhitePawns)<>0)) then
        begin
          inc(pscore,duo);
          inc(pend,duo);
        end;

       if (not pass) and ((Wstopper[sq] and BlackPawns)=0) then
        begin
          //   
          i:=sq+8; cand:=false;
          while i+8<a8 do
            begin
              if (Only[i] and all)<>0 then break;
              if ((WPAttacks[i] and BlackPawns)<>0)  then
                begin
                  if ((Wpassmask[i] and (not WPAttacks[i]) and BlackPawns)<>0) then break;
                  att:=BitCount(WpAttacks[i] and BlackPawns);
                  def:=BitCount(BpAttacks[i] and  WhitePawns);
                  if def>=att then cand:=true;
                  break;
                end;
              inc(i,8);
            end;
         if cand then
          begin
           inc(pscore,Candidat[y]);
           inc(pend,CandidatEnd[y]);
          end;
        end;
      temp:=temp and NotOnly[sq];
    end;

 //  

 temp:=BlackPawns;
  while temp<>0 do
    begin
      pass:=false;
      sq:=BitScanForward(temp);
      x:=Posx[sq];y:=posy[sq];
      dbl:=BitCount(BlackPawns and (Files[x]));
      pscore:=pscore-WPSQ[63-sq];
      //  :
      if ((BPassMask[sq] and WhitePawns)=0) then
        begin
          bpassvector:=bpassvector or Only32[x];
          pass:=true;
        end;
      if (IsoMask[sq] and BlackPawns)=0 then
         begin
          //  
           pscore:=pscore+IsoMid[x];
           if (bstopper[sq] and all)=0 then pscore:=pscore+OnOpen;
           pend:=pend+IsoEnd[x];
         end
            else
        begin
        //    
        if ((Bback[sq] and BlackPawns)=0)  then
           begin
           backward:=true;
           if ((Only[sq-8] and badv)<>0) then
            begin
             if ((WPAttacks[sq-8] and BlackPawns)<>0) then backward:=false else
               if (y=7) and ((Only[sq-16] and badv)<>0) and ((WPAttacks[sq-16] and BlackPawns)<>0) then backward:=false;
            end;
           if (backward)  then
              begin
                pscore:=pscore+WeakMid[x];
                if (Bstopper[sq] and all)=0 then pscore:=pscore+OnOpen;
                pend:=pend+WeakEnd[x];
              end;
           end;
      end;
      //   :
      if (dbl>1)  then
        begin
           pscore:=pscore+DoubledMid[x];
           pend:=pend+DoubledEnd[x];
        end;
      if ((x>1) and ((Only[sq-1] and BlackPawns)<>0)) or ((x<8) and ((Only[sq+1] and BlackPawns)<>0)) then
        begin
          dec(pscore,duo);
          dec(pend,duo);
        end;
       if (not pass) and ((Bstopper[sq] and WhitePawns)=0 )then
        begin
          //   
          i:=sq-8; cand:=false;
          while i-8>h1 do
            begin
              if (Only[i] and all)<>0 then break;
              if ((BPAttacks[i] and WhitePawns)<>0)  then
                begin
                  if ((Bpassmask[i] and (not BPAttacks[i]) and WhitePawns)<>0) then break;
                  def:=BitCount(WpAttacks[i] and BlackPawns);
                  att:=BitCount(BpAttacks[i] and WhitePawns);
                  if def>=att then cand:=true;
                  break;
                end;
              dec(i,8);
            end;
         if cand then
          begin
           dec(pscore,Candidat[9-y]);
           dec(pend,CandidatEnd[9-y]);
          end;
        end;

      temp:=temp and NotOnly[sq];
    end;
   WP:=(Files[4] or Files[5]) and WhitePawns;
   BP:=(Files[4] or Files[5]) and BlackPawns;
   if BitCount(WP or BP)<2 then center:=OpenCenter else
     if (BitCount(WP or BP)=4) and ((WP shl 8)=BP)
       then center:=ClosedCenter
       else center:=HalfOpenCenter;

   //   
   tdata:=(center shl 16) or (bpassvector shl 8) or wpassvector;
   PTable[indx].key:=tree[dir].PHash;
   PTable[indx].data:=tdata;
   PTable[indx].pend:=pend;
   PTable[indx].pscore:=pscore;
end;

Procedure PassPawnEval(color:integer;ply:integer);
//   
label l1,l2;
const
  mask : T8=(0,1,2,4,8,16,32,64,128);
var
  temp,sq1,sq,bonus,y,x,delta : integer;
begin
  temp:=wpassvector;
  while temp<>0 do
     begin
       sq1:=BitScanForward8(temp)+1;
       sq:=BitScanBackWard(WhitePawns and Files[sq1]);
       if (posy[sq]<2) or (posy[sq]>7) then goto l1;
       x:=Posx[sq];
       y:=posy[sq];
     //    :
       bonus:=PasserMid[y];
       inc(score,bonus);
    //    :
       bonus:=PasserBegin;
       delta:=120;
    //       
       if ((Wstopper[sq] and AllPieses)=0) and (not wKvadrat(color,sq,bking)) and (tree[ply].Bmat=0) then  delta:=delta+UnStoppable;
    //      
       if (not ispasserBlocked(sq,white)) then delta:=delta+FreePasser;
    //  
     if (Dist[wking,sq]=1) and (posy[wking]>=y) then inc(delta,KingSupported);
     //       
       if (x in [1,8]) and (BQR=0) and (BlackBishops=0) and (BlackKnights<>0)  then delta:=delta+PasserStrong;
       delta:=delta-AttDist*Dist[wking,sq+8];
       delta:=delta+DefDist*Dist[bking,sq+8];
    //         .
       if delta>0 then bonus:=bonus+((delta*PasserMul[y]+32) div 64);
       scoreend:=scoreend+bonus;
l1:    temp:=temp and (not Mask[sq1]);
     end;
  temp:=bpassvector;
  while temp<>0 do
     begin
       sq1:=BitScanForward8(temp)+1;
       sq:=BitScanForWard(BlackPawns and Files[sq1]);
       if (posy[sq]<2) or (posy[sq]>7) then goto l2;
       x:=Posx[sq];
       y:=posy[sq];
       //    :
       bonus:=PasserMid[9-y];
       dec(score,bonus);
       //    :
       bonus:=PasserBegin;
       delta:=120;
       //       
       if ((Bstopper[sq] and AllPieses)=0) and (not bKvadrat(color,sq,wking)) and (tree[ply].Wmat=0) then  delta:=delta+UnStoppable;
       //      
       if (not ispasserBlocked(sq,black)) then delta:=delta+FreePasser;
       
      //  
     if (Dist[bking,sq]=1) and (posy[bking]<=y) then inc(delta,KingSupported);
       //       
       if (x in [1,8]) and (WQR=0) and (WhiteBishops=0) and (WhiteKnights<>0)  then delta:=delta+PasserStrong;
       delta:=delta-AttDist*Dist[bking,sq-8];
       delta:=delta+DefDist*Dist[wking,sq-8];
    //         .
       if delta>0 then bonus:=bonus+((delta*PasserMul[9-y]+32) div 64);
       scoreend:=scoreend-bonus;
 l2:   temp:=temp and (not Mask[sq1]);
     end;
end;

end.
