unit safety;

interface
uses params,eval,bitboards;

Const
WKBSQ : Tsq =
     (
         -10,  0,-20,-35,-35,-20,  0,-10,
         -15,-10,-30,-40,-40,-30,-10,-15,
         -30,-30,-40,-60,-60,-40,-30,-30,
         -70,-70,-70,-70,-70,-70,-70,-70,
         -80,-80,-80,-80,-80,-80,-80,-80,
         -80,-80,-80,-80,-80,-80,-80,-80,
         -80,-80,-80,-80,-80,-80,-80,-80,
         -80,-80,-80,-80,-80,-80,-80,-80
     );

  WKESQ : Tsq =
     (
        -60,-40,-30,-20,-20,-30,-40,-60,
        -40,-20,-10,  0,  0,-10,-20,-40,
        -30,-10,  0, 10, 10,  0,-10,-30,
        -20,  0, 10, 20, 20, 10,  0,-20,
        -20,  0, 10, 20, 20, 10,  0,-20,
        -30,-10,  0, 10, 10,  0,-10,-30,
        -40,-20,-10,  0,  0,-10,-20,-40,
        -60,-40,-30,-20,-20,-30,-40,-60
     );
  WKKSQ : Tsq =
     (
        -60,-40,-20,-20,-20,-20,-20,-20,
        -60,-40,-20,  0,  0,  0,  0,  0,
        -60,-40,-20, 20, 20, 20, 20, 20,
        -60,-40,-20, 20, 40, 40, 40, 30,
        -60,-40,-20, 20, 60, 60, 60, 30,
        -60,-40,-20, 20, 60, 60, 60, 30,
        -60,-40,-20, 20, 40, 40, 40, 30,
        -60,-40,-20,-20,-20,-20,-20,-20
     );
  WKQSQ : Tsq =
     (
        -20,-20,-20,-20,-20,-20,-40,-60,
          0,  0,  0,  0,  0,-20,-40,-60,
         20, 20, 20, 20, 20,-20,-40,-60,
         30, 40, 40, 40, 20,-20,-40,-60,
         30, 60, 60, 60, 20,-20,-40,-60,
         30, 60, 60, 60, 20,-20,-40,-60,
         30, 40, 40, 40, 20,-20,-40,-60,
        -20,-20,-20,-20,-20,-20,-40,-60
     );

KSafety :T16=(0,0,128,192,224,240,248,252,254,255,256,256,256,256,256,256,256);
Ktropism=20;
Storm:t8=(0,0,0,0,8,20,40,25,0);
OpenKing=40;
Shelter:t8=(0,0,0,10,20,28,34,38,0);
Procedure EvaluateKings(ply:integer);
Procedure WKingSafety(ply:integer);
Procedure BKingSafety(ply:integer);
Function WKingShelter(x : integer):integer;
Function BKingShelter(x : integer):integer;
implementation


Procedure EvaluateKings(ply:integer);
//   
begin
  wendgame:=true;
  bendgame:=true;

  if (BlackQueens<>0) and (tree[ply].Bmat>12) then wendgame:=false;
  if (WhiteQueens<>0) and (tree[ply].wmat>12) then bendgame:=false;

  if ((all and abc)=0) and ((all and fgh)<>0) then
     begin
       scoreend:=scoreend+WKKSQ[wking];
       scoreend:=scoreend-WKQSQ[63-bking];
     end else
  if ((all and abc)<>0) and ((all and fgh)=0) then
     begin
       scoreend:=scoreend+WKQSQ[wking];
       scoreend:=scoreend-WKKSQ[63-bking];
     end else
     begin
       scoreend:=scoreend+WKESQ[wking];
       scoreend:=scoreend-WKESQ[63-bking];
     end;  
   //        
   wkingzone:=kingsMove[wking] or Only[wking];
   bkingzone:=kingsMove[bking] or Only[bking];
   wslide:=zoneslide[wking];
   bslide:=zoneslide[bking];
   if (not wendgame) then WKingSafety(ply);
   if (not bendgame) then BKingSafety(ply);
 //  ,        :
   if (wking<a2) and (wking<>e1) and (wking<>d1) then
        if (wrooktrap[wking-e1] and WhiteRooks)<>0 then score:=score-RookTrap;
   if (bking>h7) and (bking<>e8) and (bking<>d8) then
        if (brooktrap[bking-e8] and BlackRooks)<>0 then score:=score+RookTrap;
 //   
 if (WQR<>0) and (posy[bking]=8)  and
      ((KingsMove[bking] and BlackPawns and Ranks[7])=(KingsMove[bking] and Ranks[7]))
        then score:=score+WeakBackRank;
 if (BQR<>0) and (posy[wking]=1)  and
      ((KingsMove[wking] and WhitePawns and Ranks[2])=(KingsMove[wking] and Ranks[2]))
        then score:=score-WeakBackRank;
 
end;

Procedure WKingSafety(ply:integer);
var
  x,min,now,will,penalty:integer;
  safe : boolean;
begin
safe:=false;penalty:=-WKBSQ[wking];
if ((Only[wking] and g1h1)<>0)then
   begin
    if ((Only[g2] and WhitePawns)<>0) and ((h2h3 and WhitePawns)<>0) then safe:=true else
    if (WhitePawns and f2g3h2)=f2g3h2 then
     if (WhiteBishops and wfiank)<>0  then safe:=true;
   end
     else
   if ((Only[wking] and a1b1)<>0) then
   begin
    if ((Only[b2] and WhitePawns)<>0) and ((a2a3 and WhitePawns)<>0) then safe:=true else
    if (WhitePawns and a2b3c2)=a2b3c2 then
      if (WhiteBishops and wfianq)<>0 then safe:=true;
   end;
if not safe then
  begin
    x:=Posx[wking];
    now:=WkingShelter(x);
    now:=now*2+penalty;
    if x>1 then now:=now+WkingShelter(x-1);
    if x<8 then now:=now+WkingShelter(x+1);
    min:=now;
    if (tree[ply].Castle and 1)<>0 then
      begin
        will:=WkingShelter(7);
        will:=will*2+WkingShelter(6)+WkingShelter(8);
        if will<min then min:=will;
      end;
    if (tree[ply].Castle and 2)<>0 then
      begin
        will:=WkingShelter(2);
        will:=will*2+WkingShelter(1)+WkingShelter(3);
        if will<min then min:=will;
      end;
    penalty:=(now+min) div 2;
  end;
dec(score,penalty);
end;

Procedure BKingSafety(ply:integer);
var
  x,min,now,penalty,will:integer;
  safe : boolean;
begin
  safe:=false;penalty:=-WKBSQ[63-bking];
if ((Only[bking] and g8h8)<>0) then
  begin
    if ((Only[g7] and BlackPawns)<>0) and ((h7h6 and BlackPawns)<>0) then safe:=true else
    if (BlackPawns and f7g6h7)=f7g6h7 then
      if (BlackBishops and bfiank)<>0 then  safe:=true;
  end
     else
if ((Only[bking] and a8b8)<>0) then
  begin
   if ((Only[b7] and BlackPawns)<>0) and ((a7a6 and BlackPawns)<>0) then safe:=true else
   if (BlackPawns and a7b6c7)=a7b6c7 then
    if (BlackBishops and bfianq)<>0 then safe:=true;
  end;
if not safe then
  begin
    x:=Posx[bking];
    now:=BkingShelter(x);
    now:=now*2+penalty;
    if x>1 then now:=now+BkingShelter(x-1);
    if x<8 then now:=now+BkingShelter(x+1) ;
    min:=now;
    if (tree[ply].Castle and 4)<>0 then
      begin
        will:=BkingShelter(7);
        will:=will*2+BkingShelter(6)+BkingShelter(8);
        if will<min then min:=will;
      end;
    if (tree[ply].Castle and 8)<>0 then
      begin
        will:=BkingShelter(2);
        will:=will*2+BkingShelter(1)+BkingShelter(3);
        if will<min then min:=will;
      end;
    penalty:=(now+min) div 2;
  end;
 inc(score,penalty);
end;

Function WKingShelter(x : integer):integer;
var
   res,y:integer;
begin
res:=0;
if (Files[x] and WhitePawns)=0 then inc(res,Openking) else
 begin
   y:=Posy[BitScanForward(WhitePawns and Files[x])];
   if y>=Posy[wking]
     then inc(res,shelter[y])
     else inc(res,Openking);
 end;
if  ((Files[x] and BlackPawns)<>0) then
   begin
     y:=Posy[BitScanForWard(Files[x] and BlackPawns)];
     inc(res,Storm[9-y]);
   end;
Result:=res;
end;

Function BKingShelter(x : integer):integer;
var
   res,y:integer;
begin
res:=0;
if (Files[x] and BlackPawns)=0 then inc(res,Openking) else
 begin
   y:=Posy[BitScanBackward(BlackPawns and Files[x])];
   if y<=posy[bking]
    then inc(res,shelter[9-y])
    else inc(res,Openking);
 end;
if  ((Files[x] and WhitePawns)<>0) then 
   begin
     y:=Posy[BitScanBackWard(Files[x] and WhitePawns)];
     inc(res,storm[y]);
   end;
Result:=res;
end;
end.
